/*
 * Squawk messenger. 
 * Copyright (C) 2019  Yury Gubich <blue@macaw.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "root.h"
#include "shared/messageinfo.h"
#include "shared/identity.h"
#include "shared/info.h"

#include <QObject>

#ifdef WITH_OMEMO
#include <QXmppOmemoStorage.h>
#endif

int main(int argc, char *argv[]) {
    qRegisterMetaType<Shared::Message>("Shared::Message");
    qRegisterMetaType<Shared::MessageInfo>("Shared::MessageInfo");
    qRegisterMetaType<Shared::VCard>("Shared::VCard");
    qRegisterMetaType<std::list<Shared::Message>>("std::list<Shared::Message>");
    qRegisterMetaType<std::list<Shared::MessageInfo>>("std::list<Shared::MessageInfo>");
    qRegisterMetaType<std::list<QString>>("std::list<QString>");
    qRegisterMetaType<std::set<QString>>("std::set<QString>");
    qRegisterMetaType<std::list<Shared::Identity>>("std::list<Shared::Identity>");
    qRegisterMetaType<QSet<QString>>("QSet<QString>");
    qRegisterMetaType<Shared::ConnectionState>("Shared::ConnectionState");
    qRegisterMetaType<Shared::Availability>("Shared::Availability");
    qRegisterMetaType<Shared::EncryptionProtocol>("Shared::EncryptionProtocol");
    qRegisterMetaType<Shared::KeyInfo>("Shared::KeyInfo");
    qRegisterMetaType<Shared::Info>("Shared::Info");
    qRegisterMetaType<Shared::TrustLevel>("Shared::TrustLevel");
#ifdef WITH_OMEMO
    qRegisterMetaType<QXmppOmemoStorage::OwnDevice>("QXmppOmemoStorage::OwnDevice");
    qRegisterMetaTypeStreamOperators<QXmppOmemoStorage::OwnDevice>("QXmppOmemoStorage::OwnDevice");
    qRegisterMetaType<QXmppOmemoStorage::Device>("QXmppOmemoStorage::Device");
#endif
    
    Root app(argc, argv);
    if (!app.initializeSettings())
        return -1;

    return app.run();
}

