/*
 * Squawk messenger.
 * Copyright (C) 2019  Yury Gubich <blue@macaw.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <QString>
#include <QByteArray>
#include <QDateTime>

#include <stdint.h>

#include "enums.h"

namespace Shared {

class KeyInfo {
public:
    KeyInfo(
        uint32_t id,
        const QByteArray& fingerPrint,
        const QString& label,
        const QDateTime& lastInteraction,
        TrustLevel trustLevel,
        EncryptionProtocol protocol = EncryptionProtocol::omemo2,
        bool currentDevice = false
    );
    KeyInfo();
    KeyInfo(const KeyInfo& other);

    KeyInfo& operator=(const KeyInfo& other);

public:
    uint32_t id;
    QByteArray fingerPrint;
    QString label;
    QDateTime lastInteraction;
    TrustLevel trustLevel;
    EncryptionProtocol protocol;
    bool currentDevice;

};

}
